define(["require", "exports", "../Ion", "./FromJsConstructor", "./Value"], function (require, exports, Ion_1, FromJsConstructor_1, Value_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Boolean = void 0;
    const _fromJsConstructor = new FromJsConstructor_1.FromJsConstructorBuilder()
        .withPrimitives(FromJsConstructor_1.Primitives.Boolean)
        .withClassesToUnbox(global.Boolean)
        .build();
    class Boolean extends Value_1.Value(global.Boolean, Ion_1.IonTypes.BOOL, _fromJsConstructor) {
        constructor(value, annotations = []) {
            super(value);
            this._setAnnotations(annotations);
        }
        booleanValue() {
            return this.valueOf();
        }
        writeTo(writer) {
            writer.setAnnotations(this.getAnnotations());
            writer.writeBoolean(this.booleanValue());
        }
        _valueEquals(other, options = {
            epsilon: null,
            ignoreAnnotations: false,
            ignoreTimestampPrecision: false,
            onlyCompareIon: true,
        }) {
            let isSupportedType = false;
            let valueToCompare = null;
            if (other instanceof Boolean) {
                isSupportedType = true;
                valueToCompare = other.booleanValue();
            }
            else if (!options.onlyCompareIon) {
                if (typeof other === "boolean" || other instanceof global.Boolean) {
                    isSupportedType = true;
                    valueToCompare = other.valueOf();
                }
            }
            if (!isSupportedType) {
                return false;
            }
            if (this.booleanValue() !== valueToCompare) {
                return false;
            }
            return true;
        }
    }
    exports.Boolean = Boolean;
});
//# sourceMappingURL=Boolean.js.map